/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.datei.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.datei.entity.CsvDatei;
import de.ivu.elect.business.datei.entity.CsvDateiUK;

public abstract class AbstractCsvDateiDAO extends de.ivu.elect.jee.entity.AbstractDAO<CsvDatei,
      de.ivu.elect.business.datei.entity.DateiPK
  , CsvDateiUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractCsvDateiDAO.class);

  public AbstractCsvDateiDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.datei.entity.DateiPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public CsvDatei findByPrimaryKey(
      de.ivu.elect.business.datei.entity.DateiPK
    pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected CsvDatei findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(CsvDatei.class, id, CACHE_PROPERTIES);
  }





  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.datei.entity.CsvDateiUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.datei.entity.CsvDateiUK uk,
      de.ivu.elect.business.datei.entity.DateiPK
    pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.datei.entity.CsvDatei findByUK(de.ivu.elect.business.datei.entity.CsvDateiUK uk){

    try {
     return (de.ivu.elect.business.datei.entity.CsvDatei) getEntityManager().createNamedQuery("CSV_DATEI.UK")
                  .setParameter(1, uk
                .getErstellungszeitpunkt ()

              )
             .setParameter(2, uk
                .getOriginalDateiname ()

              )
             .setParameter(3, uk
                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("CsvDatei, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}